unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, ImgList, unit_archive,
  Buttons, IniFiles;

//-----------------------------------------------------------------------------
//  t@C̏
type
    TFileStatus = (fsNone = 0, fsExtracting, fsFinish, fsError, fsLost, fsAfter);

//=============================================================================
//  t@C𓀃Xbh
//=============================================================================
type
    TExtractThread = class(TThread)
    protected
        FIndex: integer;
        FPath: string;
        FStatus: TFileStatus;
        FMessage: string;
        procedure GetPath();
        procedure SetStatus();
        procedure ClearError();
        procedure PutMessage();
    protected
        FZip32: TArchieverDll;
        FLzh32: TArchieverDll;
        FCab32: TArchieverDll;
        procedure Execute(); override;
    end;

//=============================================================================
//  tH[
//=============================================================================
type
  TMainForm = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    Label1: TLabel;
    LblTargetDirPath: TLabel;
    Bevel1: TBevel;
    LboxTargetFile: TListBox;
    TimFindFiles: TTimer;
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuConfig: TMenuItem;
    MenuTargetExt: TMenuItem;
    MenuZip: TMenuItem;
    MenuLzh: TMenuItem;
    MenuCab: TMenuItem;
    ImageList: TImageList;
    BtnStart: TBitBtn;
    BtnStop: TBitBtn;
    BtnStart2: TBitBtn;
    FileExit: TMenuItem;
    MenuHelp: TMenuItem;
    MenuVersion: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimFindFilesTimer(Sender: TObject);
    procedure MenuCabClick(Sender: TObject);
    procedure LboxTargetFileDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BtnStartClick(Sender: TObject);
    procedure BtnStopClick(Sender: TObject);
    procedure BtnStart2Click(Sender: TObject);
    procedure FileExitClick(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
  private
    FFilePathList: TStringList;
    procedure OnFindFile(const APath: string; const ALevel: integer; var Stop: Boolean);
    procedure OnFindFolder(const APath: string; const ALevel: integer; var Skip: Boolean; var Stop: Boolean);
    procedure OnStringListChange(Sender: TObject);
  private
    FExtractThread: TExtractThread;
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    Info, Utils;

//=============================================================================
//  tH[
//=============================================================================

//-----------------------------------------------------------------------------
//  TStringList  OnChange Cxgnh
procedure TMainForm.OnStringListChange(Sender: TObject);
var
    StringList: TStringList;
    BackIndex: integer;
begin
    StringList := TStringList(Sender);

    BackIndex := LboxTargetFile.TopIndex;
    LboxTargetFile.Count := StringList.Count;
    LboxTargetFile.TopIndex := BackIndex;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
var
    IniFile: TIniFile;
begin
    //  tH[LvVݒ
    SetFormCaption(Self);

    //  Č
    IniFile := nil;
    try
        IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
        LblTargetDirPath.Caption := IniFile.ReadString(Self.Name, LblTargetDirPath.Name, LblTargetDirPath.Caption);
        MenuZip.Checked := IniFile.ReadBool(Self.Name, MenuZip.Name, MenuZip.Checked); 
        MenuLzh.Checked := IniFile.ReadBool(Self.Name, MenuLzh.Name, MenuLzh.Checked); 
        MenuCab.Checked := IniFile.ReadBool(Self.Name, MenuCab.Name, MenuCab.Checked);
    finally
        IniFile.Free;
    end;

    //  Ώۃt@CpXێXgݒ
    FFilePathList := TStringList.Create();
    FFilePathList.Duplicates := dupIgnore;
    FFilePathList.CaseSensitive := false;
    //FFilePathList.Sorted := true;
    FFilePathList.OnChange := OnStringListChange;

    //  .zip ΏۂƂ
    MenuCabClick(MenuZip);

    LboxTargetFile.ControlStyle := LboxTargetFile.ControlStyle + [csOpaque];
    LboxTargetFile.DoubleBuffered := true;

    //  𓀃Xbh쐬
    FExtractThread := TExtractThread.Create(true);
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
var
    IniFile: TIniFile;
begin
    FExtractThread.Terminate();
    if (not FExtractThread.Suspended) then
    begin
        FExtractThread.WaitFor();
    end;
    FExtractThread.Free();
    
    FFilePathList.Free;

    //  ۑ
    IniFile := nil;
    try
        IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
        IniFile.WriteString(Self.Name, LblTargetDirPath.Name, LblTargetDirPath.Caption);
        IniFile.WriteBool(Self.Name, MenuZip.Name, MenuZip.Checked);
        IniFile.WriteBool(Self.Name, MenuLzh.Name, MenuLzh.Checked);
        IniFile.WriteBool(Self.Name, MenuCab.Name, MenuCab.Checked);
    finally
        IniFile.Free;
    end;
end;

//-----------------------------------------------------------------------------
//  t@C̏
procedure TMainForm.OnFindFile(const APath: string; const ALevel: integer; var Stop: Boolean);
var
    Extension: string;
begin
    //  gqo
    Extension := AnsiUpperCase(ExtractFileExt(APath));

    //  Ώۂ̊gqǂ
    if (AnsiPos(Extension, AnsiUpperCase(StripHotkey(MenuTargetExt.Caption))) > 0) then
    begin
        if (FFilePathList.IndexOf(APath) = -1) then
        begin
            FFilePathList.AddObject(APath, TObject(fsNone));
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  tH_̏
procedure TMainForm.OnFindFolder(const APath: string; const ALevel: integer; var Skip: Boolean; var Stop: Boolean);
begin
    //  TutH_͌@Ȃ
    Skip := true;
end;

//-----------------------------------------------------------------------------
//  t@C^C}[
procedure TMainForm.TimFindFilesTimer(Sender: TObject);
var
    TargetDirPath: string;
begin
    TimFindFiles.Enabled := false;
    TimFindFiles.Interval := 1000;

    TargetDirPath := LblTargetDirPath.Caption;
    if (DirectoryExists(TargetDirPath)) then
    begin
        LboxTargetFile.Items.BeginUpdate();
        FindFiles(TargetDirPath, 0, OnFindFile, OnFindFolder);
        LboxTargetFile.Items.EndUpdate();
    end;

    TimFindFiles.Enabled := true;
end;

//-----------------------------------------------------------------------------
//  ΏۊgqύX
procedure TMainForm.MenuCabClick(Sender: TObject);
var
    ParentItem: TMenuItem;
    MenuItem: TMenuItem;
    i: integer;
    s: string;
begin
    ParentItem := TMenuItem(Sender).Parent;
    s := '';
    for i := 0 to ParentItem.Count - 1 do
    begin
        MenuItem := ParentItem.Items[i];
        if (MenuItem.Checked) then
        begin
            s := s + MenuItem.Caption + ';';
        end;
    end;
    ParentItem.Caption := '[' + s + ']';
end;

//-----------------------------------------------------------------------------
//  Xg{bNX`
procedure TMainForm.LboxTargetFileDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
    DrawTextFormat: Cardinal;
    DrawTextParams: TDrawTextParams;
    Sender: TListBox;
    Item: string;
    Status: TFileStatus;
    r: TRect;
begin
    Sender := TListBox(Control);
    Item := FFilePathList[Index];
    Status := TFileStatus(FFilePathList.Objects[Index]);

    DrawTextFormat := DT_SINGLELINE or DT_VCENTER;
    FillChar(DrawTextParams, SizeOf(DrawTextParams), 0);
    DrawTextParams.cbSize := SizeOf(DrawTextParams);
    DrawTextParams.iLeftMargin := ImageList.Width + 5;
    r := Rect;

    Sender.Canvas.FillRect(Rect);
    Sender.Canvas.Brush.Style := bsClear;
    DrawTextEx(Sender.Canvas.Handle, PChar(Item), -1, r, DrawTextFormat, @DrawTextParams);
    Sender.Canvas.Brush.Style := bsSolid;

    ImageList.Draw(Sender.Canvas, Rect.Left, Rect.Top + 2, Integer(Status));
end;

//=============================================================================
//  t@C𓀃Xbh
//=============================================================================

//-----------------------------------------------------------------------------
procedure TExtractThread.GetPath();
begin
    FPath := '';
    FIndex := MainForm.FFilePathList.IndexOfObject(TObject(fsNone));
    if (FIndex <> -1) then
    begin
        FPath := MainForm.FFilePathList[FIndex];
    end;
end;

//-----------------------------------------------------------------------------
procedure TExtractThread.SetStatus();
begin
    if (FIndex <> -1) then
    begin
        if (FStatus = fsAfter) then
        begin
            MainForm.FFilePathList.Objects[FIndex] := TObject(fsNone);
            MainForm.FFilePathList.Move(FIndex, MainForm.FFilePathList.Count - 1);
        end
        else if (FStatus = fsLost) then
        begin
            MainForm.FFilePathList.Delete(FIndex);
        end
        else
        begin
            MainForm.FFilePathList.Objects[FIndex] := TObject(FStatus);
        end;
        //MainForm.LboxTargetFile.Repaint();
        Sleep(10);
    end;    
end;

//-----------------------------------------------------------------------------
procedure TExtractThread.ClearError();
var
    i: integer;
begin
    while (true) do
    begin
        i := MainForm.FFilePathList.IndexOfObject(TObject(fsError));
        if (i <> -1) then
        begin
            MainForm.FFilePathList.Objects[i] := TObject(fsNone);
        end
        else
        begin
            break;
        end;
    end;
end;

//-----------------------------------------------------------------------------
procedure TExtractThread.PutMessage();
begin
    if (FMessage <> '') then
    begin
        PutLog(FMessage);
    end;
end;

//-----------------------------------------------------------------------------
procedure TExtractThread.Execute();
var
    Ext: string;
    Archiever: TArchieverDll;
    Attributes: integer;
    DoDelete: Boolean;
    DoAfter: Boolean;
    TempPath: string;
    FileLists: TStrings;
    FileListd: TStrings;
    i, j: integer;
    Temp: string;
    Temp2: string;
    WaitCounter: Cardinal;
begin
    FZip32 := TArchieverDll7zip32.Create();
    FLzh32 := TArchieverDllUnlha32.Create();
    FCab32 := TArchieverDllCab32.Create();
    WaitCounter := 0;

    while (not Terminated) do
    begin
        //  ҂
        if (WaitCounter > 0) then
        begin
            Dec(WaitCounter);
            Sleep(1);
            continue;
        end;

        Sleep(1);

        //  Ώۃt@CpX擾
        Synchronize(GetPath);

        //  Ώۃt@C?
        if (FPath = '') then
        begin
            Synchronize(ClearError);
            WaitCounter := 5000;
            continue;
        end;

        //  Lȃt@CpX?
        if (not FileExists(FPath)) then
        begin
            FStatus := fsLost;
            Synchronize(SetStatus);
            continue;
        end;

        //  𓀊Jn
        FStatus := fsExtracting;
        Synchronize(SetStatus);

        //  t@C̑
        Attributes := SysUtils.FileGetAttr(FPath);

        //  񂵁H
        DoAfter := (Attributes and SysUtils.faHidden <> 0);

        if (DoAfter) then
        begin
            FStatus := fsAfter;
            Synchronize(SetStatus);
            continue;
        end;

        //  H
        DoDelete := (Attributes and SysUtils.faReadOnly = 0);

        //  gq
        Ext := AnsiUpperCase(ExtractFileExt(FPath));

        if (Ext = '.ZIP') then
        begin
            Archiever := FZip32;
        end
        else if (Ext = '.LZH') then
        begin
            Archiever := FLzh32;
        end
        else if (Ext = '.CAB') then
        begin
            Archiever := FCab32;
        end
        else
        begin
            Archiever := nil;
        end;

        //  s
        if (Archiever <> nil) then
        begin
            //  KȈꎞtH_쐬
            TempPath := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
            TempPath := IncludeTrailingPathDelimiter(GetTempFolder() + TempPath);
            DeleteFolder(TempPath);
            ForceDirectories(TempPath);

            //  ̃tH_̒ɉ𓀂
            if (Archiever.Extract(FPath, TempPath, FMessage)) then
            begin
                FileLists := TStringList.Create();
                FileListd := TStringList.Create();

                //  𓀂Ăłt@Cׂė
                EnumFiles(TempPath, FileLists);
                FileListd.Assign(FileLists);

                for i := 0 to FileLists.Count - 1 do
                begin
                    Temp := FileListd[i];

                    //  tH_pXO
                    Delete(Temp, 1, Length(TempPath));

                    //  \  _ ɕϊ
                    Temp := StringReplace(Temp, '\', '_', [rfReplaceAll]);

                    //  t@C̑OɁAkt@C̊gq̖̂t _ Őڑ
                    Temp := ChangeFileExt(FPath, '_') + Temp;

                    //  łɑ݂Ăt@CpXł͂Ȃǂ`FbN
                    if (FileExists(Temp)) then
                    begin
                        //  ݂ĂȂt@CpXɂȂ悤ɉƂ
                        j := 0;
                        while true do
                        begin
                            Temp2 := ChangeFileExt(Temp, IntToHex(j, 4) + ExtractFileExt(Temp));
                            if (not FileExists(Temp2)) then
                            begin
                                Temp := Temp2;
                                break;
                            end;
                            Inc(j);
                        end;
                    end;

                    FileListd[i] := Temp;
                end;

                //  ̃tH_Ɉړ
                for i := 0 to FileLists.Count - 1 do
                begin
                    MoveFile(PChar(FileLists[i]), PChar(FileListd[i]));
                end;                

                FileLists.Free;
                FileListd.Free;

                //  KvȂIWit@C폜
                if (DoDelete) then
                begin
                    DeleteFile(FPath);
                end;

                //  Xe[^XXV
                FStatus := fsFinish;
            end
            else
            begin
                FStatus := fsError;
            end;

            //  KȈꎞtH_폜
            DeleteFolder(TempPath);

        end
        else
        begin
            FStatus := fsError;
        end;

        //  𓀏I
        Synchronize(SetStatus);
        Synchronize(PutMessage);
    end;

    FZip32.Free;
    FLzh32.Free;
    FCab32.Free;
end;

//-----------------------------------------------------------------------------
//  Jn
procedure TMainForm.BtnStartClick(Sender: TObject);
begin
    TimFindFiles.Enabled := true;
    FExtractThread.Resume();
    BtnStart.Enabled := false;
    BtnStart2.Enabled := false;
    BtnStop.Enabled := true;
end;

//-----------------------------------------------------------------------------
//  Jn2
procedure TMainForm.BtnStart2Click(Sender: TObject);
var
    Dir: string;
begin
    if (SelectDirectoryEx(Self.Handle, 'tH_I', LblTargetDirPath.Caption, Dir)) then
    begin
        LblTargetDirPath.Caption := Dir;

        TimFindFiles.Enabled := true;
        FExtractThread.Resume();
        BtnStart.Enabled := false;
        BtnStart2.Enabled := false;
        BtnStop.Enabled := true;
    end;
end;

//-----------------------------------------------------------------------------
//  ~
procedure TMainForm.BtnStopClick(Sender: TObject);
begin
    FExtractThread.Suspend();
    TimFindFiles.Enabled := false;
    BtnStart.Enabled := true;
    BtnStart2.Enabled := true;
    BtnStop.Enabled := false;
end;

procedure TMainForm.FileExitClick(Sender: TObject);
begin
    Self.Close();
end;

procedure TMainForm.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
