unit Utils;

interface

uses
    Windows, SysUtils, Classes, ShlObj, ActiveX, ShellApi, Forms;

//-----------------------------------------------------------------------------
//  e|tH_̃pX擾
function GetTempFolder(): string;

//-----------------------------------------------------------------------------
//  t@CEtH_̃R[obN֐
type
    TOnFindFile = procedure(const APath: string; const ALevel: integer; var Stop: Boolean) of object;
    TOnFindFolder = procedure(const APath: string; const ALevel: integer; var Skip: Boolean; var Stop: Boolean) of object;

//-----------------------------------------------------------------------------
//  ċAItH_
function FindFiles(const ADirPath: string; const ALevel: integer;
                    ACallbackFile: TOnFindFile; ACallbackFolder: TOnFindFolder): Boolean;

//-----------------------------------------------------------------------------
//  tH_폜
procedure DeleteFolder(const ADirPath: string);

//-----------------------------------------------------------------------------
//  t@C
procedure EnumFiles(const ADirPath: string; AList: TStrings);

//-----------------------------------------------------------------------------
//  Oo
procedure PutLog(const AText: string; const AMaxSize: Cardinal = $FFFFF);

//-----------------------------------------------------------------------------
//  tH_I{
function SelectDirectoryEx(OwnerHandle: HWND; const Caption: string;
                const Root: string; var Directory: string): Boolean;

implementation

//-----------------------------------------------------------------------------
//  e|tH_̃pX擾
//  http://www.wwlnk.com/boheme/delphi/vbtodel/daf0650.html
function GetTempFolder(): string;
var
    Temp: array[0..MAX_PATH + 1] of Char;
begin
    GetTempPath(SizeOf(Temp), Temp);
    Result := Temp;
end;

//-----------------------------------------------------------------------------
//  ċAItH_
//  Subject: [Delphi-ML:4452] Re: fBNg\𓾂ɂ́H
function FindFiles(const ADirPath: string; const ALevel: integer;
                    ACallbackFile: TOnFindFile; ACallbackFolder: TOnFindFolder): Boolean;
var
    Path: string;
    Rec: TSearchRec;
    Skip, Cancel: Boolean;
begin

    Result := True;
    Path := ADirPath;

    // ȃtH_H
    if not DirectoryExists(Path) then Exit;

    // \ ĂH
    Path := IncludeTrailingPathDelimiter(Path);

    // Ȃ񂩓Ă邩ȁH
    if FindFirst(Path + '*.*', faAnyFile, Rec) = 0 then
    begin

        // Ă݂悤
        try
            repeat
                // tH_ƐetH_͖
                if (Rec.Name = '.') or (Rec.Name = '..') then Continue;

                // XLbvȂˁH
                Skip := False;

                // LZȂˁH
                Cancel := False;

                // tH_
                if (Rec.Attr and faDirectory) <> 0 then
                begin
                    ACallbackFolder(Path + Rec.Name, ALevel, Skip, Cancel);

                    // HXLbv...
                    if Skip then Continue;

                    // HLZ...
                    if Cancel then
                    begin
                        Result := False;
                        Break;
                    end;

                    // @@
                    Result := FindFiles(Path + Rec.Name, ALevel + 1, ACallbackFile, ACallbackFolder);

                    // BLZꂽB
                    if not Result then Break;
                end else
                begin

                    // R[obN
                    ACallbackFile(Path + Rec.Name, ALevel, Cancel);

                    // HLZ...
                    if Cancel then
                    begin
                        Result := False;
                        Break;
                    end;

                end;

            until
                // ǂ܂ł
                FindNext(Rec) <> 0;
        finally
            // Еt
            FindClose(Rec);
        end;

    end;
end;

//-----------------------------------------------------------------------------
//  tH_폜
procedure DeleteFolder(const ADirPath: string);
var
    Path: string;
    Rec: TSearchRec;
begin
    Path := ADirPath;

    // ȃtH_H
    if not DirectoryExists(Path) then Exit;

    // \ ĂH
    Path := IncludeTrailingPathDelimiter(Path);

    // Ȃ񂩓Ă邩ȁH
    if FindFirst(Path + '*.*', faAnyFile, Rec) = 0 then
    begin

        // Ă݂悤
        try
            repeat
                // tH_ƐetH_͖
                if (Rec.Name = '.') or (Rec.Name = '..') then Continue;

                // tH_
                if (Rec.Attr and faDirectory) <> 0 then
                begin
                    DeleteFolder(Path + Rec.Name); 
                end

                //  t@C
                else
                begin
                    FileSetReadOnly(Path + Rec.Name, false);
                    DeleteFile(Path + Rec.Name);
                end;

            until
                // ǂ܂ł
                FindNext(Rec) <> 0;
        finally
            // Еt
            FindClose(Rec);
        end;

    end;

    //  
    RemoveDir(Path);
end;

//-----------------------------------------------------------------------------
//  t@C
procedure EnumFiles(const ADirPath: string; AList: TStrings);
var
    Path: string;
    Rec: TSearchRec;
begin
    Path := ADirPath;

    // ȃtH_H
    if not DirectoryExists(Path) then Exit;

    // \ ĂH
    Path := IncludeTrailingPathDelimiter(Path);

    // Ȃ񂩓Ă邩ȁH
    if FindFirst(Path + '*.*', faAnyFile, Rec) = 0 then
    begin

        // Ă݂悤
        try
            repeat
                // tH_ƐetH_͖
                if (Rec.Name = '.') or (Rec.Name = '..') then Continue;

                // tH_
                if (Rec.Attr and faDirectory) <> 0 then
                begin
                    EnumFiles(Path + Rec.Name, AList);
                end

                //  t@C
                else
                begin
                    AList.Add(Path + Rec.Name);
                end;

            until
                // ǂ܂ł
                FindNext(Rec) <> 0;
        finally
            // Еt
            FindClose(Rec);
        end;

    end;
end;

//-----------------------------------------------------------------------------
//  Oo
procedure PutLog(const AText: string; const AMaxSize: Cardinal = $FFFFF);
var
    LogPath: string;
    LogBack: string;
    F: TextFile;
    TempF: File;
    Size: Int64;
begin
    if AText = '' then Exit;

    //  Ot@Č
    LogPath := ChangeFileExt(ParamStr(0), '.log');
    LogBack := LogPath + '.bak';

    //  t@CTCY
    Size := 0;

    //  Ƀt@C݂Ăꍇ
    if FileExists(LogPath) then
    begin
        try
            AssignFile(TempF, LogPath);
            try
                //  oCgt@C
                Reset(TempF, 1);
                Size := FileSize(TempF);
            finally
                CloseFile(TempF);
            end;
        except
        end;
    end;

    //  t@CTCYłȂH
    if (Size >= AMaxSize) then
    begin
        //  Ât@C
        if (FileExists(LogBack)) then
        begin
            FileSetReadOnly(LogBack, false);
        end;
        DeleteFile(LogBack);

        //  ̃t@C𖼏̕ύX
        RenameFile(LogPath, LogBack);
    end;

    try
        //  t@C֘At
        AssignFile(F, LogPath);

        try
            //  Ƀt@C݂Ăꍇ
            if FileExists(LogPath) then
            begin
                //  ǉ
                Append(F);
            end

            //  ꍇ
            else
            begin
                //  쐬
                Rewrite(F);
            end;

            //  
            Writeln(F, AText);

            //  f
            Flush(F);
        finally
            //  Ō͕
            CloseFile(F);
        end;
    except
    end;
end;

//-----------------------------------------------------------------------------
//  http://forum.nifty.com/fdelphi/samples/01269.html
//  [2004/04/08]ǔSelectDirectory@\_E
function BrowseFolderProc(hWindow: HWND; uMsg: UINT; lParam: LPARAM;
                                            lpData: LPARAM): Integer; stdcall;
var
    PathName: array[0..MAX_PATH] of Char;
begin
    case uMsg of
    BFFM_INITIALIZED:
        begin
            SendMessage(hWindow, BFFM_SETSELECTION, WPARAM(True), lpData);
        end;
    BFFM_SELCHANGED:
        begin
            SHGetPathFromIDList(PItemIDList(lParam), @PathName);
            SendMessage(hWindow, BFFM_SETSTATUSTEXT, 0, LongInt(PChar(@PathName)));
        end;
    end;
    Result := 0;
end;

//-----------------------------------------------------------------------------
//  tH_I{
function SelectDirectoryEx(OwnerHandle: HWND; const Caption: string;
                const Root: string; var Directory: string): Boolean;
var
    IDList: PItemIDList;
    BI: TBrowseInfo;
    Malloc:IMalloc;
    WindowList: Pointer;
    Buffer: PChar;
begin
    Result := False;
    Directory := '';
    FillChar(BI, SizeOf(BI), 0);
    if (ShGetMalloc(Malloc) = S_OK) and (Malloc <> nil) then
    begin
        Buffer := Malloc.Alloc(MAX_PATH);
        try
            BI.hwndOwner      := OwnerHandle;
            BI.pidlRoot       := nil;
            BI.pszDisplayName := Buffer;
            BI.lpszTitle      := PChar(Caption);
            BI.ulFlags        := BIF_STATUSTEXT or BIF_RETURNONLYFSDIRS;
            BI.lpfn           := @BrowseFolderProc;
            BI.lParam         := integer(PChar(Root));

            WindowList := DisableTaskWindows(0);
            try
                IDList := ShBrowseForFolder(BI);
            finally
                EnableTaskWindows(WindowList);
            end;

            Result := (IDList <> nil);
            if Result then
            begin
                ShGetPathFromIDList(IDList, Buffer);
                Malloc.Free(IDList);
                Directory := Buffer;
            end;
        finally
            Malloc.Free(Buffer);
        end;
    end;
end;

end.

