//=============================================================================
//  k𓀂̂߂̃jbg
//  http://oto.chu.jp/kujira/text/delphi/archive.htm
//=============================================================================

//  2005.10.22  C^[tF[XύX by fjtkt@ybb.ne.jp

//              Cab32.dll   kE
//              7-zip32.dll kE
//              UNLHA32.DLL kE𓀁Eȉ𓀌`k

unit unit_archive;

interface

uses
    Windows, SysUtils, Classes;

type
    TArchieveFunc = function (const hWnd: HWND; szCmdLine: PChar; szOutput: PChar; dwSize: DWORD): Integer; stdcall;

//=============================================================================
//  Dllˑk/𓀗pNX̃x[XNX
//=============================================================================
type
    TArchieverDll = class
    protected
        FDllName: string;
        FFuncName: string;
        FExtractCommand: string;
        FCompressCommand: string;
        FDllHandle: THandle;
        FFunc: TArchieveFunc;
        function OpenDll(var Err: string): Boolean;
        procedure CloseDll();
        function Execute(const Command: string; var Msg: string): Boolean;
    public
        function Compress(SrcPathList: TStrings; const DstFile: string; var Msg: string; const OptionFlag: integer = 0): Boolean; virtual;
        function Extract(const SrcFile, DstPath: string; var Msg: string): Boolean; virtual;
    public
        constructor Create();
        destructor Destroy(); override;
    end;

//=============================================================================
//  Cab32.dll
//=============================================================================
type
    TArchieverDllCab32 = class(TArchieverDll)
    public
        constructor Create();
    end;

//=============================================================================
//  7-zip32.dll
//=============================================================================
type
    TArchieverDll7zip32 = class(TArchieverDll)
    public
        constructor Create();
    end;

//=============================================================================
//  UNLHA32.DLL
//=============================================================================
type
    TArchieverDllUnlha32 = class(TArchieverDll)
    public
        constructor Create();
        function Compress(SrcPathList: TStrings; const DstFile: string; var Msg: string; const OptionFlag: integer = 0): Boolean; override;
    end;

implementation


//=============================================================================
//  UTILITY
//=============================================================================

//-----------------------------------------------------------------------------
//  pt
function Quote(const Text: string; const QText: Char = '"'): string;
begin
    Result := AnsiQuotedStr(Text, QText);
end;

//-----------------------------------------------------------------------------
//  t@C̃XgƂ݂ȂfBNg߂(ʃhCu...)
function GetBasePath(PathList: TStringList): string;
var
    i: integer;
    s: string;
    FlagContinue: Boolean;
begin
    Result := '';

    //  XgɑSpXΒm
    if (PathList.Count = 0) then
    begin
        Exit;
    end;

    //  1ڂ̃fBNgpXo
    //  ȍ~ARZȂpXĂ̗̂pĂ(?)
    Result := ExtractFilePath(PathList[0]);
    FlagContinue := false;

    while ((Result <> '') and FlagContinue) do
    begin
        FlagContinue := false;

        //  ̑SẴpX
        for i := 0 to PathList.Count - 1 do
        begin
            //  tH_𔲂o
            s := ExtractFilePath(PathList[i]);

            //  ݂̗̍ppXƔr(?)  
            if (Copy(s, 1, Length(Result)) <> Result) then
            begin
                FlagContinue := true;
                Result := ExtractFilePath(Result);
                Break;
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  t@C̃XgfBNg폜
procedure DeleteBasePath(PathList: TStringList; const BasePath: string);
var
    i: Integer;
    s: string;
begin
    for i := 0 to PathList.Count - 1 do
    begin
        //  fBNgŎn܂pX̏ꍇ
        s := PathList[i];
        if (AnsiPos(BasePath, s) = 1) then
        begin
            //  擪؂藎Ƃ
            Delete(s, 1, Length(BasePath));
            PathList[i] := s;
        end;
    end;
end;


//=============================================================================
//  Dllˑk/𓀗pNX̃x[XNX
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TArchieverDll.Create();
begin
    inherited;
    FDllHandle := 0;
    @FFunc := nil;

    //  ȉ́AhNXœK؂ɕύX邱

    //  DLL 
    FDllName := 'UNKNOWN.DLL';

    //  ֐
    FFuncName := 'UNKNOWN';

    //  k̃tH[}bg
    FCompressCommand := 'UNKNOWN';

    //  𓀎̃tH[}bg
    FExtractCommand := 'UNKNOWN';
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TArchieverDll.Destroy();
begin
    CloseDll();
    inherited;
end;

//-----------------------------------------------------------------------------
//  DLL J
function TArchieverDll.OpenDll(var Err: string): Boolean;
begin
    //  DLL J
    FDllHandle := LoadLibrary(PChar(FDllName));

    //  G[`FbN
    Result := (FDllHandle <> 0);

    //  Ȃ
    if (Result) then
    begin
        //  ֐擾
        @FFunc := GetProcAddress(FDllHandle, PChar(FFuncName));

        //  G[`FbN
        Result := (@FFunc <> nil);

        //  Ȃ
        if Result then
        begin
            //
        end

        //  肠
        else
        begin
            CloseDll();
            Err := SysErrorMessage(GetLastError());
        end;
    end

    //  肠
    else
    begin
        Err := SysErrorMessage(GetLastError());
    end;
end;

//-----------------------------------------------------------------------------
//  DLL 
procedure TArchieverDll.CloseDll();
begin
    if (FDllHandle <> 0) then
    begin
        FreeLibrary(FDllHandle);
        FDllHandle := 0;
    end;
end;

//-----------------------------------------------------------------------------
//  R}hs
function TArchieverDll.Execute(const Command: string; var Msg: string): Boolean;
var
    Output: array[0..1023] of Char;
    PrevLen: integer;
begin
    //  DLL JāA֐擾
    Result := OpenDll(Msg);

    try
        //  ȂȂ珈s
        if (Result) then
        begin
            try
                FillChar(Output, SizeOf(Output), 0);
                //FFunc(FDllHandle, PChar(Command), Output, 1023);
                FFunc(0, PChar(Command), Output, 1023);
                Msg :=  Output;
                Result := (AnsiPos('error', LowerCase(Msg)) = 0);
            except
                on E:Exception do
                begin
                    Msg := Format('%s, %s', [E.Message, Msg]);
                end;
            end;
        end;
    finally
        CloseDll();
    end;

    //  o͐`
    Msg := Format('%s (in %s) OUTPUT:'#13#10'%s', [FFuncName, FDllName, Msg]);

    PrevLen := Length(Msg);
    while (true) do
    begin
        Msg := StringReplace(Msg, #13#10#13#10, #13#10, [rfReplaceAll]);
        if (PrevLen = Length(Msg)) then break;
        PrevLen := Length(Msg);
    end;
end;

//-----------------------------------------------------------------------------
//  k
//  OptionFlag ͎g܂BhNXŎg!?
function TArchieverDll.Compress(SrcPathList: TStrings; const DstFile: string; var Msg: string; const OptionFlag: integer): Boolean;
var
    StrBuf: TStringList;
    BasePath: string;
    i: integer;
    s, PathList: string;
    Command: string;
begin
    StrBuf := nil;
    try
        StrBuf := TStringList.Create();
        StrBuf.Assign(SrcPathList);

        //  fBNg
        BasePath := GetBasePath(StrBuf);

        //  tH_w肳Ăꍇ * t
        for i := 0 to StrBuf.Count - 1 do
        begin
            s := StrBuf[i];
            if (DirectoryExists(s)) then
            begin
                s := IncludeTrailingPathDelimiter(s) + '*';
                StrBuf[i] := s;
            end;
        end;

        //  fBNg
        DeleteBasePath(StrBuf, BasePath);

        //  t@C̈ꗗ쐬
        PathList := '';

        for i := 0 to StrBuf.Count - 1 do
        begin
            PathList := PathList + Quote(StrBuf[i]) + ' '; 
        end;

        //  R}h쐬 ... "ɖ" "fBNg" "pX"
        Command := Format(FCompressCommand, [Quote(DstFile), Quote(BasePath), PathList]);

        //  s
        Result := Execute(Command, Msg);
    finally
        StrBuf.Free;
    end;
end;

//-----------------------------------------------------------------------------
//  
function TArchieverDll.Extract(const SrcFile, DstPath: string; var Msg: string): Boolean;
var
    Command: string;
begin
    Command := Format(FExtractCommand, [Quote(SrcFile), Quote(DstPath)]);
    Result := Execute(Command, Msg);
end;

//=============================================================================
//  Cab32.dll
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TArchieverDllCab32.Create();
begin
    inherited;
    FDllName := 'cab32.dll';
    FFuncName := 'Cab';
    FCompressCommand := '-a -r %s %s %s';
    FExtractCommand := '-x %s %s';
end;

//=============================================================================
//  7-zip32.dll
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TArchieverDll7zip32.Create();
begin
    inherited;
    FDllName := '7-zip32.dll';
    FFuncName := 'SevenZip';
    FCompressCommand := 'a -r %s %s %s';
    FExtractCommand := 'x -hide %s -o%s';
end;

//=============================================================================
//  UNLHA32.DLL
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TArchieverDllUnlha32.Create();
begin
    inherited;
    FDllName := 'UNLHA32.DLL';
    FFuncName := 'Unlha';
    FCompressCommand := 'a -a1 -r2 -x1 -l1 -jp1 -o2 -ji0 %s %s %s';
    FExtractCommand := 'e -a1 -r2 -x1 -jp1 -c0 -m1 %s %s';
end;

//-----------------------------------------------------------------------------
//  k
function TArchieverDllUnlha32.Compress(SrcPathList: TStrings; const DstFile: string; var Msg: string; const OptionFlag: integer): Boolean;
var
    DstFile1: string;
    Command: string;
begin
    //  ʏ툳k
    if (OptionFlag = 0) then
    begin
        Result := inherited Compress(SrcPathList, DstFile, Msg, OptionFlag);
    end

    //  ȉ𓀌`
    else
    begin
        //  ŏɒʏ툳k
        DstFile1 := ChangeFileExt(DstFile, '.tmp');
        Result := inherited Compress(SrcPathList, DstFile1, Msg, OptionFlag);

        if (Result) then
        begin
            //  ϊ
            Command := Format('s -gw %s %s -gr%s -x1 -r2 -gx0 -gw4', [
                Quote(DstFile1),
                Quote(ExtractFilePath(DstFile1)),
                Quote(ExtractFileName(DstFile1))
                ]);
            Result := Execute(Command, Msg);

            //  t@C
            if (Result) then
            begin
                DeleteFile(DstFile1);
            end;
        end;
    end;
end;

end.
